import { readdir as q, readFile as T, writeFile as D } from "fs/promises";
import { existsSync as C, mkdirSync as K } from "fs";
import { normalize as E, join as k, extname as F } from "path";
/**
 * @license
 * Qwik Speak
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at https://github.com/robisim74/qwik-speak/blob/main/LICENSE
 */
function M(s, t = 0) {
  const a = [], u = [], f = [];
  let c = "", o = t;
  const p = (r) => (t = o, { type: r, value: w(), position: { start: t, end: o } }), b = (r) => {
    r.value = w(), r.position.start = t, r.position.end = o;
  }, v = () => s[++o], I = () => o < s.length - 1 ? s[o + 1] : "", P = () => o > 0 ? s[o - 1] : "", w = () => s.substring(t, o + 1), L = (r) => /["'`0-9+-]/.test(r), S = (r) => /[a-zA-Z_$]/.test(r), $ = (r) => /[(){},:;.[\]?!=<>]/.test(r), g = (r) => /\//.test(r) && /\*/.test(I()), x = (r, l) => {
    if (!l)
      l = p("Literal"), a.push(l);
    else {
      if (f.length === 0 && !/[0-9.]/.test(r))
        return y(r);
      b(l);
    }
    return f.length === 0 && /["'`]/.test(r) ? f.push(r) : f.length > 0 && f[f.length - 1] === r && (/\\/.test(P()) || f.pop()), x(v(), l);
  }, e = (r, l) => {
    if (!l)
      c = r, l = p("Identifier"), a.push(l);
    else if (/[0-9a-zA-Z_$. ]/.test(r))
      c += r, (c == "null" || c == "undefined" || c == "true" || c == "false" || c == "void 0") && (l.type = "Literal"), b(l);
    else
      return y(r);
    return e(v(), l);
  }, n = (r, l) => (l = p("Punctuator"), a.push(l), /\(/.test(r) ? u.push(r) : /\)/.test(r) && u.pop(), y(v())), i = (r) => /\//.test(r) && /\*/.test(P()) ? y(r) : i(v()), d = () => a[a.length - 1]?.type === "Punctuator" && u.length === 0 || o === s.length, y = (r = s[o]) => d() ? a : L(r) ? x(r) : S(r) ? e(r) : $(r) ? n(r) : g(r) ? i(r) : y(v());
  return y();
}
function Q(s, t, a) {
  let u, f = 0;
  const c = [], o = () => f < s.length - 1 ? s[f + 1] : { type: "", value: "", position: { start: 0, end: 0 } }, p = () => s[++f], b = () => s[s.length - 1], v = (e) => e.replace(/^["'`]|["'`]$/g, ""), I = (e) => (u.arguments.push({ type: "Literal", value: v(e.value) }), g(p())), P = (e) => (u.arguments.push({ type: "Identifier", value: e.value }), g(p())), w = (e, n, i) => (i || (i = {
    type: "Property",
    key: { type: "Identifier", value: e.value },
    value: { type: "Literal", value: "" }
  }, n.push(i)), !/^:$/.test(e.value) && !/^:$/.test(o().value) ? e.type === "Literal" ? (i.value.value = v(e.value), S(p(), n)) : (i.value.type = "Expression", L(e, n, i)) : w(p(), n, i)), L = (e, n, i) => (i.value.value += e.value, /^[({]$/.test(e.value) ? c.push(e.value) : /^[)}]$/.test(e.value) && c.pop(), /^[,}]$/.test(o().value) && c.length === 0 ? S(p(), n) : L(p(), n, i)), S = (e, n) => (n || (n = [], u.arguments.push({ type: "ObjectExpression", properties: n })), /^}$/.test(e.value) ? g(p()) : /^:$/.test(o().value) ? w(e, n) : S(p(), n)), $ = (e, n) => (n || (n = [], u.arguments.push({ type: "ArrayExpression", elements: n })), /^]$/.test(e.value) ? g(p()) : (e.type === "Literal" && n.push({ type: "Literal", value: v(e.value) }), e.type === "Identifier" && n.push({ type: "Identifier", value: e.value }), $(p(), n))), g = (e) => Object.is(e, b()) ? u : e.type === "Literal" ? I(e) : e.type === "Identifier" && /^\($/.test(o().value) ? x(e) : e.type === "Identifier" ? P(e) : /^{$/.test(e.value) ? S(e) : /^\[$/.test(e.value) ? $(e) : g(p()), x = (e, n, i = e.position.start) => n ? /^\)$/.test(e.value) ? (n.value = t.substring(i, e.position.end + 1), g(p())) : x(p(), n, i) : new RegExp(a).test(e.value) ? (u = {
    type: "CallExpression",
    value: t.substring(i, b().position.end + 1),
    arguments: []
  }, g(p())) : (n = { type: "CallExpression", value: "" }, u.arguments.push(n), x(p(), n, i));
  return x(s[f]);
}
function W(s, t) {
  const a = new RegExp(`${t}\\(`, "gs"), u = [];
  let f;
  for (; (f = a.exec(s)) !== null; )
    u.push(f.index);
  return u;
}
function J(s, t) {
  const a = [], u = W(s, t);
  for (const f of u) {
    const c = M(s, f);
    if (c.length > 0)
      try {
        const o = Q(c, s, t);
        o && a.push(o);
      } catch (o) {
        console.error(o), console.error(
          `
\x1B[31mQwik Speak Parser error\x1B[0m
%s`,
          s.substring(f, c[c.length - 1].position.end) + `
`
        );
      }
  }
  return a;
}
function Z(s) {
  return /inlineTranslate/.test(s);
}
function _(s) {
  return /inlinePlural/.test(s);
}
function G(s) {
  let t = s.match(/(?<=\bconst\s).*?(?=\s?=\s?inlineTranslate\(\);?)/)?.[0]?.trim();
  return t ? (t.startsWith("$") || (t = `\\b${t}`), t = t.replace(/\$/g, "\\$"), t) : null;
}
function H(s) {
  let t = s.match(/(?<=\bconst\s).*?(?=\s?=\s?inlinePlural\(\);?)/)?.[0]?.trim();
  return t ? (t.startsWith("$") || (t = `\\b${t}`), t = t.replace(/\$/g, "\\$"), t) : null;
}
function U(s) {
  return JSON.parse(s, (t, a) => a === null || a === "" ? void 0 : a);
}
function X(s, t, a) {
  let u = 0;
  const f = t.length;
  for (; u < f; ) {
    const c = t[u++];
    s[c] = s[c] && !a ? s[c] : u === f ? a : typeof s[c] == "object" ? s[c] : {}, s = s[c];
  }
}
function N(s, t) {
  return typeof s == "object" && typeof t == "object" ? (Object.keys(t).map((a) => {
    s[a] = N(s[a], t[a]);
  }), s) : t;
}
function Y(s) {
  return typeof s == "object" ? JSON.parse(JSON.stringify(s)) : s;
}
function ee(s, t) {
  return s = { ...s, ...t }, s;
}
function te(s) {
  return JSON.stringify(s, se, 2);
}
function R(s) {
  return Object.keys(s).sort().reduce(
    (t, a) => (typeof s[a] == "object" && !Array.isArray(s[a]) ? t[a] = R(s[a]) : t[a] = s[a], t),
    {}
  );
}
function se(s, t) {
  return typeof t == "string" ? t.replace(/\\/g, "") : t;
}
function ne(s, t) {
  const a = /* @__PURE__ */ new Set();
  for (let u = 0; u < 20; u++) {
    const f = new Intl.PluralRules(s, t).select(u);
    a.add(f);
  }
  return Array.from(a);
}
function re(s) {
  let t;
  if (s) {
    t = {};
    for (const a of s)
      t = { ...t, [a.key.value]: a.value.value };
  }
  return t;
}
async function oe(s) {
  const t = {
    ...s,
    basePath: s.basePath ?? "./",
    sourceFilesPaths: s.sourceFilesPaths ?? ["src"],
    excludedPaths: s.excludedPaths ?? [],
    assetsPath: s.assetsPath ?? "i18n",
    format: s.format ?? "json",
    filename: s.filename ?? "app",
    keySeparator: s.keySeparator ?? ".",
    keyValueSeparator: s.keyValueSeparator ?? "@@"
  }, a = /* @__PURE__ */ new Map(), u = t.sourceFilesPaths.map((e) => E(`${t.basePath}/${e}`)), f = t.excludedPaths.map((e) => E(`${t.basePath}/${e}`)), c = [], o = Object.fromEntries(t.supportedLangs.map((e) => [e, {}])), p = async (e, n) => {
    const i = await q(e, { withFileTypes: !0 });
    for (const d of i) {
      const y = k(e, d.name), r = F(d.name);
      d.isDirectory() ? n.includes(y) || await p(y, n) : /\.js|\.ts|\.jsx|\.tsx/.test(r) && !/test|spec/.test(d.name) && c.push(y);
    }
  }, b = (e) => e.type === "Identifier" || e.type === "Literal" && e.value && /\${.*}/.test(e.value) ? (a.set("dynamic", (a.get("dynamic") ?? 0) + 1), !0) : !1, v = async (e) => {
    const n = [];
    let i = await T(E(`${t.basePath}/${e}`), "utf8");
    const d = (r) => {
      i = i.replace(new RegExp(`${r}<.*>\\(`, "g"), `${r.replace("\\b", "")}(`);
    }, y = (r) => {
      for (const l of r) {
        const h = l.arguments;
        if (h?.length > 0) {
          if (h[0].type === "ArrayExpression") {
            if (h[0].elements) {
              for (const m of h[0].elements)
                if (m.type === "Literal") {
                  if (b(m))
                    continue;
                  n.push(m.value);
                }
            }
          } else if (h?.[0]?.value) {
            if (b(h[0]))
              continue;
            n.push(h[0].value);
          }
        }
      }
    };
    if (Z(i)) {
      const r = G(i);
      if (r) {
        d(r);
        const l = J(i, r);
        y(l);
      }
    }
    if (_(i)) {
      const r = H(i);
      if (r) {
        const l = J(i, r);
        for (const h of l) {
          const m = h.arguments;
          if (m?.length > 0) {
            if (m[1]?.type === "Identifier" || m[1]?.type === "CallExpression" || m[3]?.type === "Identifier" || m[3]?.type === "CallExpression") {
              a.set("dynamic plural", (a.get("dynamic plural") ?? 0) + 1);
              continue;
            }
            const j = /* @__PURE__ */ new Set(), V = re(m[3]?.properties);
            for (const A of t.supportedLangs) {
              const O = ne(A, V);
              for (const z of O)
                j.add(z);
            }
            const B = m?.[1]?.value;
            if (B) {
              const A = {};
              for (const O of j)
                A[O] = "";
              n.push(`${B}${t.keyValueSeparator}${JSON.stringify(A)}`);
            } else
              for (const A of j)
                n.push(A);
          }
        }
      }
    }
    return n;
  }, I = async () => {
    const e = /* @__PURE__ */ new Map();
    for (const n of t.supportedLangs) {
      const i = E(`${t.basePath}/${t.assetsPath}/${n}`);
      if (C(i)) {
        const d = await q(i);
        if (d.length > 0) {
          const y = F(d[0]);
          let r = {};
          const l = d.map((m) => T(`${i}/${m}`, "utf8")), h = await Promise.all(l);
          for (const m of h)
            if (m) {
              let j = {};
              switch (y) {
                case ".json":
                  j = U(m);
                  break;
              }
              r = ee(r, j);
            }
          e.set(n, r);
        }
      }
    }
    return e;
  }, P = async (e) => {
    for (const n of t.supportedLangs) {
      const i = E(`${t.basePath}/${t.assetsPath}/${n}`);
      C(i) || K(i, { recursive: !0 });
      const d = Object.keys(o[n]).filter((l) => !e.includes(l)), y = Object.keys(o[n]).filter((l) => e.includes(l)), r = {};
      o[n][t.filename] && (r[t.filename] = o[n][t.filename]);
      for (const l of y)
        r[l] = o[n][l];
      Object.keys(r).length > 0 && await w(r, t.filename, i);
      for (const l of d.filter((h) => h !== t.filename))
        await w({ [l]: o[n][l] }, l, i);
    }
  }, w = async (e, n, i) => {
    let d;
    switch (t.format) {
      case "json":
        d = te(e);
        break;
    }
    const y = E(`${i}/${n}.${t.format}`);
    await D(y, d), console.log(y);
  };
  for (const e of u)
    await p(e, f);
  const L = c.map((e) => v(e)), S = await Promise.all(L);
  let $ = [];
  for (const e of S)
    $ = $.concat(e);
  $ = [...new Set($)], a.set("unique keys", (a.get("unique keys") ?? 0) + $.length);
  const g = [];
  for (let e of $) {
    let n;
    [e, n] = e.split(t.keyValueSeparator), /^[[{].*[\]}]$/.test(n) && !/^{{/.test(n) && (n = JSON.parse(n));
    for (const i of t.supportedLangs)
      X(o[i], e.split(t.keySeparator), Y(n || ""));
    g.push(e);
  }
  const x = await I();
  if (x.size > 0)
    for (const [e, n] of x)
      N(o[e], n);
  for (const e of t.supportedLangs)
    o[e] = R(o[e]);
  await P(g);
  for (const [e, n] of a)
    switch (e) {
      case "unique keys":
        console.log("\x1B[32m%s\x1B[0m", `extracted keys: ${n}`);
        break;
      case "dynamic":
        console.log("\x1B[32m%s\x1B[0m", `translations skipped due to dynamic keys: ${n}`);
        break;
      case "dynamic plural":
        console.log("\x1B[32m%s\x1B[0m", `plurals skipped due to dynamic keys/options: ${n}`);
        break;
    }
}
export {
  oe as qwikSpeakExtract
};
