import type { Plugin } from 'vite';

/**
 * Qwik Speak Inline Vite plugin
 */
export declare function qwikSpeakInline(options: QwikSpeakInlineOptions): Plugin;

/**
 * Qwik Speak Inline Vite Plugin Options
 */
export declare interface QwikSpeakInlineOptions {
    /**
     * The base path. Default to './'
     */
    basePath?: string;
    /**
     * Path to translation files: [basePath]/[assetsPath]/[lang]/*.json. Default to 'i18n'
     */
    assetsPath?: string;
    /**
     * The build output directory. Default to 'dist'
     */
    outDir?: string;
    /**
     * Supported langs. Required
     */
    supportedLangs: string[];
    /**
     * Default lang. Required
     */
    defaultLang: string;
    /**
     * Separator of nested keys. Default is '.'
     */
    keySeparator?: string;
    /**
     * Key-value separator. Default is '@@'
     */
    keyValueSeparator?: string;
}

export { }
