import { readdir as W, readFile as z, writeFile as _ } from "fs/promises";
import { createWriteStream as G, existsSync as M, mkdirSync as K } from "fs";
import { normalize as E, extname as Z } from "path";
/**
 * @license
 * Qwik Speak
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at https://github.com/robisim74/qwik-speak/blob/main/LICENSE
 */
function H(e, t = 0) {
  const s = [], i = [], l = [];
  let u = "", n = t;
  const r = (c) => (t = n, { type: c, value: $(), position: { start: t, end: n } }), a = (c) => {
    c.value = $(), c.position.start = t, c.position.end = n;
  }, f = () => e[++n], y = () => n < e.length - 1 ? e[n + 1] : "", m = () => n > 0 ? e[n - 1] : "", $ = () => e.substring(t, n + 1), v = (c) => /["'`0-9+-]/.test(c), w = (c) => /[a-zA-Z_$]/.test(c), P = (c) => /[(){},:;.[\]?!=<>]/.test(c), b = (c) => /\//.test(c) && /\*/.test(y()), I = (c, g) => {
    if (!g)
      g = r("Literal"), s.push(g);
    else {
      if (l.length === 0 && !/[0-9.]/.test(c))
        return S(c);
      a(g);
    }
    return l.length === 0 && /["'`]/.test(c) ? l.push(c) : l.length > 0 && l[l.length - 1] === c && (/\\/.test(m()) || l.pop()), I(f(), g);
  }, o = (c, g) => {
    if (!g)
      u = c, g = r("Identifier"), s.push(g);
    else if (/[0-9a-zA-Z_$. ]/.test(c))
      u += c, (u == "null" || u == "undefined" || u == "true" || u == "false" || u == "void 0") && (g.type = "Literal"), a(g);
    else
      return S(c);
    return o(f(), g);
  }, p = (c, g) => (g = r("Punctuator"), s.push(g), /\(/.test(c) ? i.push(c) : /\)/.test(c) && i.pop(), S(f())), d = (c) => /\//.test(c) && /\*/.test(m()) ? S(c) : d(f()), Q = () => s[s.length - 1]?.type === "Punctuator" && i.length === 0 || n === e.length, S = (c = e[n]) => Q() ? s : v(c) ? I(c) : w(c) ? o(c) : P(c) ? p(c) : b(c) ? d(c) : S(f());
  return S();
}
function U(e, t, s) {
  let i, l = 0;
  const u = [], n = () => l < e.length - 1 ? e[l + 1] : { type: "", value: "", position: { start: 0, end: 0 } }, r = () => e[++l], a = () => e[e.length - 1], f = (o) => o.replace(/^["'`]|["'`]$/g, ""), y = (o) => (i.arguments.push({ type: "Literal", value: f(o.value) }), b(r())), m = (o) => (i.arguments.push({ type: "Identifier", value: o.value }), b(r())), $ = (o, p, d) => (d || (d = {
    type: "Property",
    key: { type: "Identifier", value: o.value },
    value: { type: "Literal", value: "" }
  }, p.push(d)), !/^:$/.test(o.value) && !/^:$/.test(n().value) ? o.type === "Literal" ? (d.value.value = f(o.value), w(r(), p)) : (d.value.type = "Expression", v(o, p, d)) : $(r(), p, d)), v = (o, p, d) => (d.value.value += o.value, /^[({]$/.test(o.value) ? u.push(o.value) : /^[)}]$/.test(o.value) && u.pop(), /^[,}]$/.test(n().value) && u.length === 0 ? w(r(), p) : v(r(), p, d)), w = (o, p) => (p || (p = [], i.arguments.push({ type: "ObjectExpression", properties: p })), /^}$/.test(o.value) ? b(r()) : /^:$/.test(n().value) ? $(o, p) : w(r(), p)), P = (o, p) => (p || (p = [], i.arguments.push({ type: "ArrayExpression", elements: p })), /^]$/.test(o.value) ? b(r()) : (o.type === "Literal" && p.push({ type: "Literal", value: f(o.value) }), o.type === "Identifier" && p.push({ type: "Identifier", value: o.value }), P(r(), p))), b = (o) => Object.is(o, a()) ? i : o.type === "Literal" ? y(o) : o.type === "Identifier" && /^\($/.test(n().value) ? I(o) : o.type === "Identifier" ? m(o) : /^{$/.test(o.value) ? w(o) : /^\[$/.test(o.value) ? P(o) : b(r()), I = (o, p, d = o.position.start) => p ? /^\)$/.test(o.value) ? (p.value = t.substring(d, o.position.end + 1), b(r())) : I(r(), p, d) : new RegExp(s).test(o.value) ? (i = {
    type: "CallExpression",
    value: t.substring(d, a().position.end + 1),
    arguments: []
  }, b(r())) : (p = { type: "CallExpression", value: "" }, i.arguments.push(p), I(r(), p, d));
  return I(e[l]);
}
function X(e, t) {
  const s = new RegExp(`${t}\\(`, "gs"), i = [];
  let l;
  for (; (l = s.exec(e)) !== null; )
    i.push(l.index);
  return i;
}
function A(e, t) {
  const s = [], i = X(e, t);
  for (const l of i) {
    const u = H(e, l);
    if (u.length > 0)
      try {
        const n = U(u, e, t);
        n && s.push(n);
      } catch (n) {
        console.error(n), console.error(
          `
\x1B[31mQwik Speak Parser error\x1B[0m
%s`,
          e.substring(l, u[u.length - 1].position.end) + `
`
        );
      }
  }
  return s;
}
function Y(e) {
  return /inlineTranslate/.test(e);
}
function ee(e) {
  return /inlinePlural/.test(e);
}
function te(e) {
  let t = e.match(/(?<=\bconst\s).*?(?=\s?=\s?inlineTranslate\(\);?)/)?.[0]?.trim();
  return t ? (t.startsWith("$") || (t = `\\b${t}`), t = t.replace(/\$/g, "\\$"), t) : null;
}
function ne(e) {
  let t = e.match(/(?<=\bconst\s).*?(?=\s?=\s?inlinePlural\(\);?)/)?.[0]?.trim();
  return t ? (t.startsWith("$") || (t = `\\b${t}`), t = t.replace(/\$/g, "\\$"), t) : null;
}
function se(e) {
  return JSON.parse(e, (t, s) => s === null || s === "" ? void 0 : s);
}
function re(e, t) {
  const s = /* @__PURE__ */ new Set();
  for (let i = 0; i < 20; i++) {
    const l = new Intl.PluralRules(e, t).select(i);
    s.add(l);
  }
  return Array.from(s);
}
function ie(e) {
  let t;
  if (e) {
    t = {};
    for (const s of e)
      t = { ...t, [s.key.value]: s.value.value };
  }
  return t;
}
function le(e, t) {
  return e = { ...e, ...t }, e;
}
const q = "__qsInlineTranslate", T = "__qsInlinePlural", k = [], R = [], ae = (e, t) => `${e} - ${t}`, ue = (e, t) => `dynamic ${t}: ${e}`;
let x, j, L;
function ke(e) {
  const t = {
    ...e,
    basePath: e.basePath ?? "./",
    assetsPath: e.assetsPath ?? "i18n",
    outDir: e.outDir ?? "dist",
    keySeparator: e.keySeparator ?? ".",
    keyValueSeparator: e.keyValueSeparator ?? "@@"
  }, s = Object.fromEntries(t.supportedLangs.map((n) => [n, {}]));
  let i;
  const l = /* @__PURE__ */ new Set();
  return {
    name: "vite-plugin-qwik-speak-inline",
    enforce: "post",
    apply: void 0,
    // both
    configResolved(n) {
      n.build?.ssr || n.mode === "ssr" ? x = "ssr" : n.mode === "lib" ? x = "lib" : n.mode === "test" ? x = "test" : x = "client", j = n.isProduction || n.mode === "production" ? "prod" : "dev";
      const r = n.build?.rollupOptions?.input;
      r && (Array.isArray(r) ? L = r[0] : typeof r == "string" && (L = r)), L = L?.split("/")?.pop();
    },
    configureServer(n) {
      j === "dev" && n.ws.on("qwik-speak:lang", (r) => {
        if (i && i !== r.msg) {
          for (const a of l) {
            const f = n.moduleGraph.getModuleById(a);
            f && n.moduleGraph.invalidateModule(f);
          }
          l.clear();
        }
        i = r.msg;
      });
    },
    handleHotUpdate({ file: n, server: r }) {
      if (new RegExp(t.assetsPath).test(n) && /\.(json)$/.test(n)) {
        for (const a of t.supportedLangs)
          new RegExp(a).test(n) && D(s, [a], t.basePath, t.assetsPath);
        for (const a of l) {
          const f = r.moduleGraph.getModuleById(a);
          f && r.moduleGraph.invalidateModule(f);
        }
        l.clear();
      }
    },
    /**
     * Load translation files when build starts
     */
    async buildStart() {
      (x === "client" || j === "dev") && await D(
        s,
        t.supportedLangs,
        t.basePath,
        t.assetsPath
      );
    },
    /**
     * Transform functions
     * Prefer transform hook because unused imports will be removed, unlike renderChunk
     */
    async transform(n, r, a) {
      if ((x === "client" || x === "ssr" && a?.ssr === !1) && /\/src\//.test(r) && /\.(js|cjs|mjs|jsx|ts|tsx)$/.test(r))
        return ee(n) && (n = ce(n)), Y(n) && (n = fe(n)), j === "dev" && (n.includes(q) || n.includes(T)) && (n = N(n, i, t, s), l.add(r)), n;
      x === "ssr" && (r.endsWith("entry.ssr.tsx") || r.endsWith("entry.ssr.jsx")) && (/(?<!\/\/\s*)base:\s*extractBase/.test(n) || (console.log(
        `
\x1B[31mQwik Speak Inline error\x1B[0m
%s`,
        "Missing 'base' option in 'entry.ssr.tsx' file: see https://robisim74.gitbook.io/qwik-speak/tools/setup"
      ), process.exit(1)));
    },
    /**
     * Split chunks by lang
     */
    async writeBundle(n, r) {
      if (x === "client") {
        const a = n.dir ? n.dir : E(`${t.basePath}/${t.outDir}`), f = Object.values(r), y = t.supportedLangs.map((m) => oe(m, f, a, s, t));
        await Promise.all(y);
      }
    },
    async closeBundle() {
      if (x === "client") {
        const n = G("./qwik-speak-inline.log", { flags: "w" });
        n.write(`${x}: ` + (L ?? "-") + `
`), n.write(`
Missing value for keys:
`), k.forEach((r) => n.write(r + `
`)), n.write(`
Make sure the keys are in 'runtimeAssets':
`), R.forEach((r) => n.write(r + `
`)), n.write(`
Qwik Speak Inline: build ends at ${(/* @__PURE__ */ new Date()).toLocaleString()}
`), (k.length > 0 || R.length > 0) && console.log(
          `
\x1B[33mQwik Speak Inline warn\x1B[0m
%s`,
          "There are missing values or dynamic keys: see ./qwik-speak-inline.log"
        );
      }
    }
  };
}
async function D(e, t, s, i) {
  await Promise.all(t.map(async (l) => {
    const u = E(`${s}/${i}/${l}`);
    if (M(u)) {
      const n = await W(u);
      if (n.length > 0) {
        const r = Z(n[0]);
        let a = {};
        const f = n.map((m) => z(`${u}/${m}`, "utf8")), y = await Promise.all(f);
        for (const m of y)
          if (m) {
            let $ = {};
            switch (r) {
              case ".json":
                $ = se(m);
                break;
            }
            a = le(a, $);
          }
        e[l] = { ...e[l], ...a };
      }
    }
  }));
}
async function oe(e, t, s, i, l) {
  const u = E(`${s}/build/${e}`);
  M(u) || K(u, { recursive: !0 });
  for (const n of t) {
    const r = [];
    if (n.type === "chunk" && "code" in n && /build\//.test(n.fileName)) {
      const a = E(`${u}/${n.fileName.split("/")[1]}`);
      let f = n.code;
      if (f = N(f, e, l, i), r.push(_(a, f)), e === l.defaultLang) {
        const y = E(`${s}/build`), m = E(`${y}/${n.fileName.split("/")[1]}`);
        r.push(_(m, f));
      }
    }
    await Promise.all(r);
  }
}
function fe(e) {
  const t = te(e);
  if (!t)
    return e;
  let s = !1;
  const i = A(e, t);
  if (i.length === 0)
    return e;
  for (const l of i) {
    const u = l.value, n = l.arguments;
    if (n?.length > 0) {
      if ($e(n, u)) {
        s = !0;
        continue;
      }
      const r = u.replace(new RegExp(`${t}\\(`), `${q}(`);
      e = e.replace(u, r);
    }
  }
  return s || (e = Ee(e, t)), e;
}
function ce(e) {
  const t = ne(e);
  if (!t)
    return e;
  let s = !1;
  const i = A(e, t);
  if (i.length === 0)
    return e;
  for (const l of i) {
    const u = l.value, n = l.arguments;
    if (n?.length > 0) {
      if (ge(n, u)) {
        s = !0;
        continue;
      }
      const r = u.replace(new RegExp(`${t}\\(`), `${T}(`);
      e = e.replace(u, r);
    }
  }
  return s || (e = Le(e, t)), e;
}
function N(e, t, s, i) {
  return e.includes(T) && (e = ye(e, T, q, t, s)), e.includes(q) && (e = pe(e, i, q, t, s)), e;
}
function pe(e, t, s, i, l) {
  const u = A(e, s);
  if (u.length === 0)
    return e;
  for (const n of u) {
    const r = n.value, a = n.arguments;
    if (a?.length > 0) {
      const f = J(i, a[2], l);
      let y = h("");
      if (a[0].type === "ArrayExpression") {
        const $ = ve(a[0]), v = [];
        for (const w of $) {
          const P = C(
            w,
            t[f],
            a[1],
            l.keySeparator,
            l.keyValueSeparator,
            f
          );
          v.push(P);
        }
        y = v;
      } else if (a?.[0]?.value) {
        const $ = he(a[0]);
        y = C(
          $,
          t[f],
          a[1],
          l.keySeparator,
          l.keyValueSeparator,
          f
        );
      }
      const m = me(y);
      e = e.replace(r, m);
    }
  }
  return e;
}
function ye(e, t, s, i, l) {
  const u = A(e, t);
  if (u.length === 0)
    return e;
  for (const n of u) {
    const r = n.value, a = n.arguments;
    if (a?.length > 0) {
      const f = J(i, a[4], l), y = ie(a[3]?.properties), m = re(f, y), $ = de(m, f, s, a, l);
      e = e.replace(r, $);
    }
  }
  return e;
}
function me(e) {
  return typeof e == "object" ? `${be(e)}` : e;
}
function de(e, t, s, i, l) {
  let u = "";
  return u += ((r) => {
    let a = "(";
    for (const f of e) {
      let y = i[1]?.value;
      y = y ? `${y}${l.keySeparator}${f}` : f;
      const m = [{
        type: "Property",
        key: { type: "Identifier", value: "value" },
        value: { type: "Expression", value: i[0].value }
      }];
      if (i[2]?.properties)
        for (const v of i[2].properties)
          m.push(v);
      const $ = m.map((v) => `${v.key.value}: ${F(v)}`).join(", ");
      if (f !== e[e.length - 1]) {
        const v = i[3]?.properties?.map((P) => `${P.key.value}: ${F(P)}`)?.join(", "), w = Pe(r, i[0].value, f, v);
        a += w + ` && ${s}(${h(y)}, {${$}}, ${h(r)}) || `;
      } else
        a += `${s}(${h(y)}, {${$}}, ${h(r)})`;
    }
    return a += ")", a;
  })(t), u;
}
function $e(e, t) {
  if (e?.[0]?.value) {
    if (e[0].type === "Identifier" || e[0].type === "Literal" && /\${.*}/.test(e[0].value))
      return O(t, "key"), !0;
    if (e[1]?.type === "Identifier" || e[1]?.type === "CallExpression" || e[2]?.type === "Identifier" || e[2]?.type === "CallExpression")
      return O(t, "params"), !0;
  }
  return !1;
}
function ge(e, t) {
  return e?.[0]?.value && (e[1]?.type === "Identifier" || e[1]?.type === "CallExpression" || e[2]?.type === "Identifier" || e[2]?.type === "CallExpression" || e[3]?.type === "Identifier" || e[3]?.type === "CallExpression" || e[4]?.type === "Identifier" || e[4]?.type === "CallExpression") ? (O(t, "params"), !0) : !1;
}
function J(e, t, s) {
  let i;
  return t?.type === "Literal" && (i = s.supportedLangs.find((l) => l === t.value)), i ?? e;
}
function he(e) {
  return e.value;
}
function ve(e) {
  const t = [];
  if (e.elements)
    for (const s of e.elements)
      s.type === "Literal" && t.push(s.value);
  return t;
}
const xe = (e, t) => e.split(t);
function C(e, t, s, i, l, u) {
  let n;
  [e, n] = xe(e, l);
  const r = e.split(i).reduce((a, f) => a && a[f] !== void 0 ? a[f] : void 0, t);
  if (r) {
    if (typeof r == "string")
      return s ? V(r, s) : h(r);
    if (typeof r == "object")
      return s ? B(r, s) : r;
  } else
    u && Ie(u, e);
  return n ? !/^[[{].*[\]}]$/.test(n) || /^{{/.test(n) ? s ? V(n, s) : h(n) : s ? B(JSON.parse(n), s) : JSON.parse(n) : h(j === "dev" ? e : "");
}
function B(e, t) {
  return Object.keys(e).map((s) => {
    typeof e[s] == "string" && (e[s] = t ? V(e[s], t) : h(e[s])), e[s] && typeof e[s] == "object" && (e[s] = B(e[s], t));
  }), e;
}
function V(e, t) {
  if (t.properties)
    for (const s of t.properties)
      e = e.replace(/{{\s?([^{}\s]*)\s?}}/g, (i, l) => l === s.key.value ? we(s) : i);
  return h(e);
}
function h(e) {
  return /^`.*`$/.test(e) ? e : "`" + e + "`";
}
function we(e) {
  return e.value.type === "Literal" ? e.value.value : "${" + e.value.value + "}";
}
function F(e) {
  return e.value.type === "Literal" ? h(e.value.value) : e.value.value;
}
function Pe(e, t, s, i) {
  return i ? `new Intl.PluralRules(${h(e)}, {${i}}).select(+${t}) === ${h(s)}` : `new Intl.PluralRules(${h(e)}).select(+${t}) === ${h(s)}`;
}
function be(e) {
  let t = JSON.stringify(e, je);
  return t = t.replace(/("__qsOpenBt)|(__qsCloseBt")/g, "`"), t;
}
function Ie(e, t) {
  const s = ae(e, t);
  k.includes(s) || k.push(s);
}
function O(e, t) {
  const s = ue(Se(e), t);
  R.includes(s) || R.push(s);
}
function Se(e) {
  return e.replace(/\s+/g, " ").trim();
}
function Ee(e, t) {
  return e.replace(new RegExp(`\\bconst\\s${t}\\s=\\sinlineTranslate\\(\\);?`, "g"), "");
}
function Le(e, t) {
  return e.replace(new RegExp(`\\bconst\\s${t}\\s=\\sinlinePlural\\(\\);?`, "g"), "");
}
function je(e, t) {
  return typeof t == "string" && /^`.*`$/.test(t) ? t.replace(/^`/, "__qsOpenBt").replace(/`$/, "__qsCloseBt") : t;
}
export {
  ke as qwikSpeakInline
};
